
#ifndef VisComplexElementPtrFUNCTIONTYPES_H
#define VisComplexElementPtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisComplexElementPtr if VisComplexElement is set: */
#define EMPTYVisComplexElementHDR
#ifndef EMPTYHDR
#include "VisComplexElement.h"
#endif
#undef EMPTYVisComplexElementHDR

typedef int (*VisComplexElementPtrCmpFctType) ELI_ARG((VisComplexElementPtr, VisComplexElementPtr));
/* Functions that compare two VisComplexElementPtr values
 *   If the left argument is less than the right then on exit-
 *     VisComplexElementPtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisComplexElementPtrCmpFctType = 0
 *   Else on exit-
 *     VisComplexElementPtrCmpFctType = 1
 ***/

typedef VisComplexElementPtr (*VisComplexElementPtrMapFct) ELI_ARG((VisComplexElementPtr));
/* Functions that map one VisComplexElementPtr value into another
 *   On exit-
 *     VisComplexElementPtrMapFct = image of the argument under the map
 ***/

typedef VisComplexElementPtr (*VisComplexElementPtrSumFct) ELI_ARG((VisComplexElementPtr, VisComplexElementPtr));
/* Functions that combine two VisComplexElementPtr values
 *   On exit-
 *     VisComplexElementPtrSumFct = combination of the two arguments
 ***/

#endif
