
#ifndef VisConstraintVariablePtrFUNCTIONTYPES_H
#define VisConstraintVariablePtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisConstraintVariablePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisConstraintVariablePtrCmpFctType) ELI_ARG((VisConstraintVariablePtr, VisConstraintVariablePtr));
/* Functions that compare two VisConstraintVariablePtr values
 *   If the left argument is less than the right then on exit-
 *     VisConstraintVariablePtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisConstraintVariablePtrCmpFctType = 0
 *   Else on exit-
 *     VisConstraintVariablePtrCmpFctType = 1
 ***/

typedef VisConstraintVariablePtr (*VisConstraintVariablePtrMapFct) ELI_ARG((VisConstraintVariablePtr));
/* Functions that map one VisConstraintVariablePtr value into another
 *   On exit-
 *     VisConstraintVariablePtrMapFct = image of the argument under the map
 ***/

typedef VisConstraintVariablePtr (*VisConstraintVariablePtrSumFct) ELI_ARG((VisConstraintVariablePtr, VisConstraintVariablePtr));
/* Functions that combine two VisConstraintVariablePtr values
 *   On exit-
 *     VisConstraintVariablePtrSumFct = combination of the two arguments
 ***/

#endif
