#include "stdlib.h"
#include "tcl.h"
#include "tk.h"

#ifdef __cplusplus
extern "C" 
#endif
int Vl_Init(Tcl_Interp *interp);


#ifdef __cplusplus
extern "C" 
#endif
int App_Init(Tcl_Interp *interp)
{
    printf("Mein Init aufgerufen!");

	if (Tcl_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Tk_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Vl_Init(interp) == TCL_ERROR)
		return TCL_ERROR;

	return TCL_OK;
}

/* The following is just a dummy function used in the Eli derivation to */
/* make sure that the main program gets included. */
#ifdef __cplusplus
extern "C" 
#endif
int ___Eli_Main()
{
    return 0;
}

int main(int argc, char *argv[]) 
{
    Tk_Main(argc, argv, App_Init);
    
    exit(0);
    return 0;
}

