
/* encoding of tree node types and symbols */

#ifndef NODECODE_H
#define NODECODE_H

extern int LHSMAP[];

#define IsSymb(_n,_c) (LHSMAP[(_n)->_prod] == (_c))

#define SYMBStateList 0
#define SYMB_List_Substate 1
#define SYMBTransitionList 2
#define SYMB_List_Transition 3
#define SYMBStatechart 4
#define SYMBROOT 5
#define SYMBSubstate 6
#define SYMBSimpleState 7
#define SYMBXORName 8
#define SYMBXORSubstates 9
#define SYMBXORSuperstate 10
#define SYMBANDName 11
#define SYMBANDRegions 12
#define SYMB_List_ANDRegion 13
#define SYMBANDSuperstate 14
#define SYMBANDRegion 15
#define SYMBTransitionLabel 16
#define SYMBTransition 17
#define SYMBLST__List_Substate 18
#define SYMBLST__List_ANDRegion 19
#define SYMBLST__List_Transition 20
#define RULELST_0p_List_ANDRegion 0
#define RULELST_0p_List_Substate 1
#define RULELST_0p_List_Transition 2
#define RULELST_ANDRegionp_List_ANDRegion 3
#define RULELST_Substatep_List_Substate 4
#define RULELST_Transitionp_List_Transition 5
#define RULERule_1 6
#define RULERule_10 7
#define RULERule_11 8
#define RULERule_12 9
#define RULERule_2 10
#define RULERule_3 11
#define RULERule_4 12
#define RULERule_5 13
#define RULERule_6 14
#define RULERule_7 15
#define RULERule_8 16
#define RULERule_9 17
#define RULEpANDRegion 18
#define RULEpANDSuperstate 19
#define RULEpSimpleState 20
#define RULEpTransition 21
#define RULEpXORSuperstate 22
#define RULEp_List_ANDRegion 23
#define RULEp_List_Substate 24
#define RULEp_List_Transition 25
#endif
