#ifndef NORESTORE
#include "obsave.h"
#endif
#include "pdl_gen.h"

#ifdef MONITOR
#include "pdl_dapto.h"
#endif

#define PRESENT find(key, _property, (Entry *)&_Item, 0)
#define VALUE (_Item->PropVal)

#define TYPE VLPointArrayPtr

#define ACCESS find(key, _property, (Entry *)&_Item, sizeof(struct VLPointArrayPtrElt))

typedef struct VLPointArrayPtrElt {
	Entry next;
	int selector;
	TYPE PropVal;
} *VLPointArrayPtrProperty;

#if defined(__STDC__) || defined(__cplusplus)
TYPE
GetVLPointArrayPtr (int _property, DefTableKey key, TYPE deflt)
#else
TYPE
GetVLPointArrayPtr (_property, key, deflt)
int _property;
DefTableKey key;
TYPE deflt;
#endif
{  VLPointArrayPtrProperty _Item;
{ if (key == NoKey) return deflt;
  if (PRESENT) return VALUE;
  else return deflt;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
SetVLPointArrayPtr (int _property, DefTableKey key, TYPE _add, TYPE _replace)
#else
void
SetVLPointArrayPtr (_property, key, _add, _replace)
int _property;
DefTableKey key;
TYPE _add;
TYPE _replace;
#endif
{  VLPointArrayPtrProperty _Item;
{ if (key == NoKey) return;
  if (ACCESS) VALUE = _replace;
  else VALUE = _add;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
ResetVLPointArrayPtr (int _property, DefTableKey key, TYPE _val)
#else
void
ResetVLPointArrayPtr (_property, key, _val)
int _property;
DefTableKey key;
TYPE _val;
#endif
{  VLPointArrayPtrProperty _Item;
{ if (key == NoKey) return;
  ACCESS; VALUE = _val;
}
}

#undef ACCESS
#undef TYPE
#define TYPE int

#define ACCESS find(key, _property, (Entry *)&_Item, sizeof(struct intElt))

typedef struct intElt {
	Entry next;
	int selector;
	TYPE PropVal;
} *intProperty;

#if defined(__STDC__) || defined(__cplusplus)
TYPE
Getint (int _property, DefTableKey key, TYPE deflt)
#else
TYPE
Getint (_property, key, deflt)
int _property;
DefTableKey key;
TYPE deflt;
#endif
{  intProperty _Item;
{ if (key == NoKey) return deflt;
  if (PRESENT) return VALUE;
  else return deflt;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
Setint (int _property, DefTableKey key, TYPE _add, TYPE _replace)
#else
void
Setint (_property, key, _add, _replace)
int _property;
DefTableKey key;
TYPE _add;
TYPE _replace;
#endif
{  intProperty _Item;
{ if (key == NoKey) return;
  if (ACCESS) VALUE = _replace;
  else VALUE = _add;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
Resetint (int _property, DefTableKey key, TYPE _val)
#else
void
Resetint (_property, key, _val)
int _property;
DefTableKey key;
TYPE _val;
#endif
{  intProperty _Item;
{ if (key == NoKey) return;
  ACCESS; VALUE = _val;
}
}

#undef ACCESS
#undef TYPE
#define TYPE VisRelationTypeReferencePtrList

#define ACCESS find(key, _property, (Entry *)&_Item, sizeof(struct VisRelationTypeReferencePtrListElt))

typedef struct VisRelationTypeReferencePtrListElt {
	Entry next;
	int selector;
	TYPE PropVal;
} *VisRelationTypeReferencePtrListProperty;

#if defined(__STDC__) || defined(__cplusplus)
TYPE
GetVisRelationTypeReferencePtrList (int _property, DefTableKey key, TYPE deflt)
#else
TYPE
GetVisRelationTypeReferencePtrList (_property, key, deflt)
int _property;
DefTableKey key;
TYPE deflt;
#endif
{  VisRelationTypeReferencePtrListProperty _Item;
{ if (key == NoKey) return deflt;
  if (PRESENT) return VALUE;
  else return deflt;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
SetVisRelationTypeReferencePtrList (int _property, DefTableKey key, TYPE _add, TYPE _replace)
#else
void
SetVisRelationTypeReferencePtrList (_property, key, _add, _replace)
int _property;
DefTableKey key;
TYPE _add;
TYPE _replace;
#endif
{  VisRelationTypeReferencePtrListProperty _Item;
{ if (key == NoKey) return;
  if (ACCESS) VALUE = _replace;
  else VALUE = _add;
}
}

#if defined(__STDC__) || defined(__cplusplus)
void
ResetVisRelationTypeReferencePtrList (int _property, DefTableKey key, TYPE _val)
#else
void
ResetVisRelationTypeReferencePtrList (_property, key, _val)
int _property;
DefTableKey key;
TYPE _val;
#endif
{  VisRelationTypeReferencePtrListProperty _Item;
{ if (key == NoKey) return;
  ACCESS; VALUE = _val;
}
}

#undef ACCESS
#undef TYPE

static struct PdlGenState
{
	struct PropElt PDLe0;
} state = {
	{(Entry)0, 0}
};

#ifndef NORESTORE

void *SaveModulePdlgen()
{
	return (void *)0;
}

void
#if defined(__cplusplus) || defined(__STDC__) 
RestoreModulePdlgen(void *base)
#else
RestoreModulePdlgen(base) void *base;
#endif
{
}

#endif

DefTableKey
#if defined(__STDC__) || defined(__cplusplus)
CloneKey (DefTableKey key)
#else
CloneKey (key)
    DefTableKey key;
#endif
{
  DefTableKey k;
  Entry e;

  if (key == NoKey) return NoKey;
  k = NewKey ();
  for (e = key->List; (e != (Entry)0) && (e->selector != 0);
       e = e->next) {
    switch (e->selector) {
      case 1:
         Resetpos (k, ((VLPointArrayPtrProperty)e)->PropVal);
         break;
      case 2:
         Resetkind (k, ((intProperty)e)->PropVal);
         break;
      case 3:
         Resetshape (k, ((intProperty)e)->PropVal);
         break;
      case 4:
         Resetdirection (k, ((intProperty)e)->PropVal);
         break;
      case 5:
         Resettotheend (k, ((intProperty)e)->PropVal);
         break;
      case 6:
         Resettarget (k, ((intProperty)e)->PropVal);
         break;
      case 7:
         Resetarea (k, ((VLPointArrayPtrProperty)e)->PropVal);
         break;
      case 8:
         Resetrelationinfo (k, ((intProperty)e)->PropVal);
         break;
      case 9:
         Resetfromrelations (k, ((VisRelationTypeReferencePtrListProperty)e)->PropVal);
         break;
      case 10:
         Resettorelations (k, ((VisRelationTypeReferencePtrListProperty)e)->PropVal);
         break;
      case 11:
         Resetdif (k, ((VLPointArrayPtrProperty)e)->PropVal);
         break;
      }
  }
  return k;
}

#ifdef MONITOR
static char *pdl_names[] = {
    (char *)0,
    "pos",
    "kind",
    "shape",
    "direction",
    "totheend",
    "target",
    "area",
    "relationinfo",
    "fromrelations",
    "torelations",
    "dif",
};
static char *pdl_types[] = {
    (char *)0,
    "VLPointArrayPtr",
    "int",
    "int",
    "int",
    "int",
    "int",
    "VLPointArrayPtr",
    "int",
    "VisRelationTypeReferencePtrList",
    "VisRelationTypeReferencePtrList",
    "VLPointArrayPtr",
};

void
#if defined(__STDC__) || defined(__cplusplus)
pdl_mon_properties(DefTableKey k)
#else
pdl_mon_properties(k) DefTableKey k;
#endif
{
    Entry e;
    if (k == NoKey) return;
    for (e = k->List; (e != (Entry)0) && (e->selector != 0);
         e = e->next) {
        DAPTO_RESULT_STR (pdl_names[e->selector]);
        DAPTO_RESULT_STR (pdl_types[e->selector]);
        switch (e->selector) {
            case 1:
#ifdef DAPTO_RESULTVLPointArrayPtr
                DAPTO_RESULTVLPointArrayPtr (((VLPointArrayPtrProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((VLPointArrayPtrProperty)e)->PropVal);
#endif
                break;
            case 2:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 3:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 4:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 5:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 6:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 7:
#ifdef DAPTO_RESULTVLPointArrayPtr
                DAPTO_RESULTVLPointArrayPtr (((VLPointArrayPtrProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((VLPointArrayPtrProperty)e)->PropVal);
#endif
                break;
            case 8:
#ifdef DAPTO_RESULTint
                DAPTO_RESULTint (((intProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((intProperty)e)->PropVal);
#endif
                break;
            case 9:
#ifdef DAPTO_RESULTVisRelationTypeReferencePtrList
                DAPTO_RESULTVisRelationTypeReferencePtrList (((VisRelationTypeReferencePtrListProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((VisRelationTypeReferencePtrListProperty)e)->PropVal);
#endif
                break;
            case 10:
#ifdef DAPTO_RESULTVisRelationTypeReferencePtrList
                DAPTO_RESULTVisRelationTypeReferencePtrList (((VisRelationTypeReferencePtrListProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((VisRelationTypeReferencePtrListProperty)e)->PropVal);
#endif
                break;
            case 11:
#ifdef DAPTO_RESULTVLPointArrayPtr
                DAPTO_RESULTVLPointArrayPtr (((VLPointArrayPtrProperty)e)->PropVal);
#else
                DAPTO_RESULT_OTHER (((VLPointArrayPtrProperty)e)->PropVal);
#endif
                break;
            default: DAPTO_RESULT_STR ("unknown property");
        }
    }
}
#endif
