#ifndef PDL_GEN_H
#define PDL_GEN_H

#include "deftbl.h"

#ifdef ELI_ARG
#undef ELI_ARG
#endif

#if defined(__STDC__) || defined(__cplusplus)
#define ELI_ARG(proto)    proto
#else
#define ELI_ARG(proto)    ()
#endif

#include "BasicTypes.h"
#include "BasicTypes.h"
#include "VisConnectionPatternCode.h"
#include "VisConnectionPatternCode.h"
#include "BasicTypes.h"

#define TYPE VLPointArrayPtr
extern TYPE GetVLPointArrayPtr ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetVLPointArrayPtr ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetVLPointArrayPtr ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE int
extern TYPE Getint ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void Setint ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void Resetint ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE VisRelationTypeReferencePtrList
extern TYPE GetVisRelationTypeReferencePtrList ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetVisRelationTypeReferencePtrList ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetVisRelationTypeReferencePtrList ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE

#define Setpos(key, _add, _replace)   \
		SetVLPointArrayPtr(1, (key), (_add), (_replace))
#define Resetpos(key, _val)   \
		ResetVLPointArrayPtr(1, (key), (_val))
#define Getpos(key, deflt)   \
		GetVLPointArrayPtr(1, (key), (deflt))
#define Setkind(key, _add, _replace)   \
		Setint(2, (key), (_add), (_replace))
#define Resetkind(key, _val)   \
		Resetint(2, (key), (_val))
#define Getkind(key, deflt)   \
		Getint(2, (key), (deflt))
#define Setshape(key, _add, _replace)   \
		Setint(3, (key), (_add), (_replace))
#define Resetshape(key, _val)   \
		Resetint(3, (key), (_val))
#define Getshape(key, deflt)   \
		Getint(3, (key), (deflt))
#define Setdirection(key, _add, _replace)   \
		Setint(4, (key), (_add), (_replace))
#define Resetdirection(key, _val)   \
		Resetint(4, (key), (_val))
#define Getdirection(key, deflt)   \
		Getint(4, (key), (deflt))
#define Settotheend(key, _add, _replace)   \
		Setint(5, (key), (_add), (_replace))
#define Resettotheend(key, _val)   \
		Resetint(5, (key), (_val))
#define Gettotheend(key, deflt)   \
		Getint(5, (key), (deflt))
#define Settarget(key, _add, _replace)   \
		Setint(6, (key), (_add), (_replace))
#define Resettarget(key, _val)   \
		Resetint(6, (key), (_val))
#define Gettarget(key, deflt)   \
		Getint(6, (key), (deflt))
#define Setarea(key, _add, _replace)   \
		SetVLPointArrayPtr(7, (key), (_add), (_replace))
#define Resetarea(key, _val)   \
		ResetVLPointArrayPtr(7, (key), (_val))
#define Getarea(key, deflt)   \
		GetVLPointArrayPtr(7, (key), (deflt))
#define Setrelationinfo(key, _add, _replace)   \
		Setint(8, (key), (_add), (_replace))
#define Resetrelationinfo(key, _val)   \
		Resetint(8, (key), (_val))
#define Getrelationinfo(key, deflt)   \
		Getint(8, (key), (deflt))
#define Setfromrelations(key, _add, _replace)   \
		SetVisRelationTypeReferencePtrList(9, (key), (_add), (_replace))
#define Resetfromrelations(key, _val)   \
		ResetVisRelationTypeReferencePtrList(9, (key), (_val))
#define Getfromrelations(key, deflt)   \
		GetVisRelationTypeReferencePtrList(9, (key), (deflt))
#define Settorelations(key, _add, _replace)   \
		SetVisRelationTypeReferencePtrList(10, (key), (_add), (_replace))
#define Resettorelations(key, _val)   \
		ResetVisRelationTypeReferencePtrList(10, (key), (_val))
#define Gettorelations(key, deflt)   \
		GetVisRelationTypeReferencePtrList(10, (key), (deflt))
#define Setdif(key, _add, _replace)   \
		SetVLPointArrayPtr(11, (key), (_add), (_replace))
#define Resetdif(key, _val)   \
		ResetVLPointArrayPtr(11, (key), (_val))
#define Getdif(key, deflt)   \
		GetVLPointArrayPtr(11, (key), (deflt))

extern struct PropList PDLk[];


extern DefTableKey CloneKey ELI_ARG((DefTableKey key));
/* Clone a definition
 *    On entry-
 *       key=a valid definition
 *    On exit-
 *       CloneKey=Unique definition with the same properties
 *                and property values as key
 ***/

#ifdef MONITOR
extern void pdl_mon_properties ELI_ARG((DefTableKey));
#endif

#endif
