
#ifndef STD_DRAWINGS_H
#define STD_DRAWINGS_H

#include "VisAutoPatternCode.h"


class FrameDrawing: public VisVectorDrawing
//    ============
{
public:
  FrameDrawing(
    char *attr, 
    VisBorderDimensions innerPad, 
    VisIntVector minSize=VisIntVector(1,1), 
    VisIntVector align=VisIntVector(VisAlignScale,VisAlignScale));
};


class RoundedFrameDrawing: public VisVectorDrawing
//    ===================
{
public:
  RoundedFrameDrawing(
    char *attr, 
    VisBorderDimensions innerPad, 
    int cornerradius, 
    VisIntVector align = VisIntVector(VisAlignScale, VisAlignScale));
};


class CircleFrameDrawing: public VisVectorDrawing
//    ===================
{
public:
  CircleFrameDrawing(
    char *attr, 
    VisBorderDimensions innerPad, 
    VisIntVector minSize = VisIntVector(1,1), 
    VisIntVector align = VisIntVector(VisAlignScale, VisAlignScale));
};


class OvalFrameDrawing: public VisVectorDrawing
//    ================
{
public:
  OvalFrameDrawing(
    char *attr, 
    VisBorderDimensions innerPad, 
    VisIntVector minSize = VisIntVector(1,1), 
    VisIntVector align = VisIntVector(VisAlignScale, VisAlignScale));
};


#endif
