
#include "HEAD.h"
#include "err.h"
#include "node.h"
#include "visitprocs_check.h"
#include "attrpredef.h"

#include "visitmap_check.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#include "liga_dapto.h"
#endif

#ifndef _VisitVarDecl
#define _VisitVarDecl()
#endif

#ifndef _VisitEntry
#define _VisitEntry()
#endif

#ifndef _VisitExit
#define _VisitExit()
#endif


#if defined(__STDC__) || defined(__cplusplus)
#define _CALL_VS_(args) (void (*)args)
#else
#define _CALL_VS_(args) 
#endif
VLPointArray _check_AVStatechart_persview0Size;
VLPointArrayPtr _check_AVStatechart__ptr_persview0Size;
VLString _check_AVStatechart_persName;
VLStringPtr _check_AVStatechart__ptr_persName;
VLPointArray _check_AVSubstate_persview0Pos;
VLPointArrayPtr _check_AVSubstate__ptr_persview0Pos;
VLPointArray _check_AVSimpleState_persview0SavedPos;
VLPointArrayPtr _check_AVSimpleState__ptr_persview0SavedPos;
VLString _check_AVSimpleState_persName;
VLStringPtr _check_AVSimpleState__ptr_persName;
VLPropertyPtr _check_AVSimpleState_persEndpoint;
VLPointArray _check_AVXORSuperstate_persview0SavedPos;
VLPointArrayPtr _check_AVXORSuperstate__ptr_persview0SavedPos;
VLPointArray _check_AVXORSuperstate_persview0Size;
VLPointArrayPtr _check_AVXORSuperstate__ptr_persview0Size;
VLPropertyPtr _check_AVXORSuperstate_persEndpoint;
VLString _check_AVXORSuperstate_persName;
VLStringPtr _check_AVXORSuperstate__ptr_persName;
VLPointArray _check_AVANDSuperstate_persview0SavedPos;
VLPointArrayPtr _check_AVANDSuperstate__ptr_persview0SavedPos;
VLPropertyPtr _check_AVANDSuperstate_persEndpoint;
VLString _check_AVANDSuperstate_persName;
VLStringPtr _check_AVANDSuperstate__ptr_persName;
VLPointArray _check_AVANDRegion_persview0Pos;
VLPointArrayPtr _check_AVANDRegion__ptr_persview0Pos;
VLPointArray _check_AVANDRegion_persview0Size;
VLPointArrayPtr _check_AVANDRegion__ptr_persview0Size;
VLPointArray _check_AVTransitionLabel_persview0Pos;
VLPointArrayPtr _check_AVTransitionLabel__ptr_persview0Pos;
VLPointArray _check_AVTransition_persview0Pos;
VLPointArrayPtr _check_AVTransition__ptr_persview0Pos;
VLPointArray _check_AVTransition_persview0FromOffset;
VLPointArrayPtr _check_AVTransition__ptr_persview0FromOffset;
VLPointArray _check_AVTransition_persview0ToOffset;
VLPointArrayPtr _check_AVTransition__ptr_persview0ToOffset;
VLPointArray _check_AVTransition_persview0SavedFromOffset;
VLPointArrayPtr _check_AVTransition__ptr_persview0SavedFromOffset;
VLPointArray _check_AVTransition_persview0SavedToOffset;
VLPointArrayPtr _check_AVTransition__ptr_persview0SavedToOffset;
VLPointArray _check_AVTransition_persview0IntermediatePoints;
VLPointArrayPtr _check_AVTransition__ptr_persview0IntermediatePoints;
VLPropertyPtr _check_AVTransition_persFrom;
VLPropertyPtr _check_AVTransition_persTo;
VLString _check_AVTransition_persEvent;
VLStringPtr _check_AVTransition__ptr_persEvent;

#if defined(__STDC__) || defined(__cplusplus)
void LIGA_ATTREVAL_check (NODEPTR _currn)
#else
void LIGA_ATTREVAL_check (_currn) NODEPTR _currn;
#endif
{(*(_check_VS1MAP[_currn->_prod])) ((NODEPTR)_currn);}
/*SPC(0)*/

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS0Empty(NODEPTR _currn)
#else
void _check_VS0Empty(_currn) NODEPTR _currn;
#endif
{ _VisitVarDecl()
_VisitEntry();

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_1(_TPPRule_1 _currn)
#else
void _check_VS1Rule_1(_currn )
_TPPRule_1 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_2(_TPPRule_2 _currn)
#else
void _check_VS1Rule_2(_currn )
_TPPRule_2 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_3(_TPPRule_3 _currn)
#else
void _check_VS1Rule_3(_currn )
_TPPRule_3 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);
_check_AVStatechart_persview0Size=_currn->_ATTERM_1;
/*SPC(9)*/
_check_AVStatechart__ptr_persview0Size=ADDROF(_currn->_ATTERM_1);
/*SPC(10)*/
_check_AVStatechart_persName=_currn->_ATTERM_2;
/*SPC(11)*/
_check_AVStatechart__ptr_persName=ADDROF(_currn->_ATTERM_2);
/*SPC(12)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_4(_TPPRule_4 _currn)
#else
void _check_VS1Rule_4(_currn )
_TPPRule_4 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1pSimpleState(_TPPpSimpleState _currn)
#else
void _check_VS1pSimpleState(_currn )
_TPPpSimpleState _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
_check_AVSubstate_persview0Pos=_currn->_ATTERM_1;
/*SPC(19)*/
_check_AVSubstate__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(20)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_5(_TPPRule_5 _currn)
#else
void _check_VS1Rule_5(_currn )
_TPPRule_5 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
_check_AVSimpleState_persview0SavedPos=_currn->_ATTERM_1;
/*SPC(24)*/
_check_AVSimpleState__ptr_persview0SavedPos=ADDROF(_currn->_ATTERM_1);
/*SPC(25)*/
_check_AVSimpleState_persName=_currn->_ATTERM_2;
/*SPC(26)*/
_check_AVSimpleState__ptr_persName=ADDROF(_currn->_ATTERM_2);
/*SPC(27)*/
_check_AVSimpleState_persEndpoint=_currn->_ATTERM_3;
/*SPC(28)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_6(_TPPRule_6 _currn)
#else
void _check_VS1Rule_6(_currn )
_TPPRule_6 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_7(_TPPRule_7 _currn)
#else
void _check_VS1Rule_7(_currn )
_TPPRule_7 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1pXORSuperstate(_TPPpXORSuperstate _currn)
#else
void _check_VS1pXORSuperstate(_currn )
_TPPpXORSuperstate _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
_check_AVSubstate_persview0Pos=_currn->_ATTERM_1;
/*SPC(38)*/
_check_AVSubstate__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(39)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_8(_TPPRule_8 _currn)
#else
void _check_VS1Rule_8(_currn )
_TPPRule_8 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);
_check_AVXORSuperstate_persview0SavedPos=_currn->_ATTERM_1;
/*SPC(43)*/
_check_AVXORSuperstate__ptr_persview0SavedPos=ADDROF(_currn->_ATTERM_1);
/*SPC(44)*/
_check_AVXORSuperstate_persview0Size=_currn->_ATTERM_2;
/*SPC(45)*/
_check_AVXORSuperstate__ptr_persview0Size=ADDROF(_currn->_ATTERM_2);
/*SPC(46)*/
_check_AVXORSuperstate_persEndpoint=_currn->_ATTERM_3;
/*SPC(47)*/
_check_AVXORSuperstate_persName=_currn->_ATTERM_4;
/*SPC(48)*/
_check_AVXORSuperstate__ptr_persName=ADDROF(_currn->_ATTERM_4);
/*SPC(49)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_9(_TPPRule_9 _currn)
#else
void _check_VS1Rule_9(_currn )
_TPPRule_9 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_10(_TPPRule_10 _currn)
#else
void _check_VS1Rule_10(_currn )
_TPPRule_10 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1pANDSuperstate(_TPPpANDSuperstate _currn)
#else
void _check_VS1pANDSuperstate(_currn )
_TPPpANDSuperstate _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
_check_AVSubstate_persview0Pos=_currn->_ATTERM_1;
/*SPC(59)*/
_check_AVSubstate__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(60)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_11(_TPPRule_11 _currn)
#else
void _check_VS1Rule_11(_currn )
_TPPRule_11 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);
_check_AVANDSuperstate_persview0SavedPos=_currn->_ATTERM_1;
/*SPC(64)*/
_check_AVANDSuperstate__ptr_persview0SavedPos=ADDROF(_currn->_ATTERM_1);
/*SPC(65)*/
_check_AVANDSuperstate_persEndpoint=_currn->_ATTERM_2;
/*SPC(66)*/
_check_AVANDSuperstate_persName=_currn->_ATTERM_3;
/*SPC(67)*/
_check_AVANDSuperstate__ptr_persName=ADDROF(_currn->_ATTERM_3);
/*SPC(68)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1pANDRegion(_TPPpANDRegion _currn)
#else
void _check_VS1pANDRegion(_currn )
_TPPpANDRegion _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
_check_AVANDRegion_persview0Pos=_currn->_ATTERM_1;
/*SPC(72)*/
_check_AVANDRegion__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(73)*/
_check_AVANDRegion_persview0Size=_currn->_ATTERM_2;
/*SPC(74)*/
_check_AVANDRegion__ptr_persview0Size=ADDROF(_currn->_ATTERM_2);
/*SPC(75)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1Rule_12(_TPPRule_12 _currn)
#else
void _check_VS1Rule_12(_currn )
_TPPRule_12 _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
_check_AVTransitionLabel_persview0Pos=_currn->_ATTERM_1;
/*SPC(79)*/
_check_AVTransitionLabel__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(80)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1pTransition(_TPPpTransition _currn)
#else
void _check_VS1pTransition(_currn )
_TPPpTransition _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
_check_AVTransition_persview0Pos=_currn->_ATTERM_1;
/*SPC(84)*/
_check_AVTransition__ptr_persview0Pos=ADDROF(_currn->_ATTERM_1);
/*SPC(85)*/
_check_AVTransition_persview0FromOffset=_currn->_ATTERM_2;
/*SPC(86)*/
_check_AVTransition__ptr_persview0FromOffset=ADDROF(_currn->_ATTERM_2);
/*SPC(87)*/
_check_AVTransition_persview0ToOffset=_currn->_ATTERM_3;
/*SPC(88)*/
_check_AVTransition__ptr_persview0ToOffset=ADDROF(_currn->_ATTERM_3);
/*SPC(89)*/
_check_AVTransition_persview0SavedFromOffset=_currn->_ATTERM_4;
/*SPC(90)*/
_check_AVTransition__ptr_persview0SavedFromOffset=ADDROF(_currn->_ATTERM_4);
/*SPC(91)*/
_check_AVTransition_persview0SavedToOffset=_currn->_ATTERM_5;
/*SPC(92)*/
_check_AVTransition__ptr_persview0SavedToOffset=ADDROF(_currn->_ATTERM_5);
/*SPC(93)*/
_check_AVTransition_persview0IntermediatePoints=_currn->_ATTERM_6;
/*SPC(94)*/
_check_AVTransition__ptr_persview0IntermediatePoints=ADDROF(_currn->_ATTERM_6);
/*SPC(95)*/
_check_AVTransition_persFrom=_currn->_ATTERM_7;
/*SPC(96)*/
_check_AVTransition_persTo=_currn->_ATTERM_8;
/*SPC(97)*/
_check_AVTransition_persEvent=_currn->_ATTERM_9;
/*SPC(98)*/
_check_AVTransition__ptr_persEvent=ADDROF(_currn->_ATTERM_9);
/*SPC(99)*/

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1p_List_Substate(_TPPp_List_Substate _currn)
#else
void _check_VS1p_List_Substate(_currn )
_TPPp_List_Substate _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1p_List_ANDRegion(_TPPp_List_ANDRegion _currn)
#else
void _check_VS1p_List_ANDRegion(_currn )
_TPPp_List_ANDRegion _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1p_List_Transition(_TPPp_List_Transition _currn)
#else
void _check_VS1p_List_Transition(_currn )
_TPPp_List_Transition _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_Substatep_List_Substate(_TPPLST_Substatep_List_Substate _currn)
#else
void _check_VS1LST_Substatep_List_Substate(_currn )
_TPPLST_Substatep_List_Substate _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_ANDRegionp_List_ANDRegion(_TPPLST_ANDRegionp_List_ANDRegion _currn)
#else
void _check_VS1LST_ANDRegionp_List_ANDRegion(_currn )
_TPPLST_ANDRegionp_List_ANDRegion _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_Transitionp_List_Transition(_TPPLST_Transitionp_List_Transition _currn)
#else
void _check_VS1LST_Transitionp_List_Transition(_currn )
_TPPLST_Transitionp_List_Transition _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc1->_prod])))((NODEPTR) _currn->_desc1);
(*(_CALL_VS_((NODEPTR )) (_check_VS1MAP[_currn->_desc2->_prod])))((NODEPTR) _currn->_desc2);

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_0p_List_Substate(_TPPLST_0p_List_Substate _currn)
#else
void _check_VS1LST_0p_List_Substate(_currn )
_TPPLST_0p_List_Substate _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_0p_List_ANDRegion(_TPPLST_0p_List_ANDRegion _currn)
#else
void _check_VS1LST_0p_List_ANDRegion(_currn )
_TPPLST_0p_List_ANDRegion _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();

_VisitExit();
}

#if defined(__STDC__) || defined(__cplusplus)
void _check_VS1LST_0p_List_Transition(_TPPLST_0p_List_Transition _currn)
#else
void _check_VS1LST_0p_List_Transition(_currn )
_TPPLST_0p_List_Transition _currn;

#endif
{

_VisitVarDecl()
_VisitEntry();

_VisitExit();
}

