

proc lineHandle_begin {params datavar x y} {
  upvar $datavar data
  set data(handleStartPosX) $x
  set data(handleStartPosY) $y
}

proc lineHandle_do {params datavar x y} {
}

proc lineHandle_end {params datavar x y} {
  upvar $datavar data
  set delete [expr abs($data(handleStartPosX)-$x)<4 && abs($data(handleStartPosY)-$y)<4]

  set nodePtr [lindex $params 0]
  set attrName [lindex $params 1]
  set index [lindex $params 2]
  puts $index
  # An/Vor welchem Listenelement wird geaendert?
  set insert [lindex $params 3]

  set list [::treeutil::getAttr $nodePtr $attrName]
  if $insert {
    set list [linsert $list [expr 2*$index] $x $y]
  } else {
    if $delete {
      set list [lreplace $list [expr 2*$index] [expr 2*$index+1]]
    } else {
      set list [lreplace $list [expr 2*$index] [expr 2*$index+1] $x $y]
    }
  }
  ::treeutil::setAttr $nodePtr $attrName $list
}


