
#ifndef VisContainerInterfacePtrFUNCTIONTYPES_H
#define VisContainerInterfacePtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisContainerInterfacePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisContainerInterfacePtrCmpFctType) ELI_ARG((VisContainerInterfacePtr, VisContainerInterfacePtr));
/* Functions that compare two VisContainerInterfacePtr values
 *   If the left argument is less than the right then on exit-
 *     VisContainerInterfacePtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisContainerInterfacePtrCmpFctType = 0
 *   Else on exit-
 *     VisContainerInterfacePtrCmpFctType = 1
 ***/

typedef VisContainerInterfacePtr (*VisContainerInterfacePtrMapFct) ELI_ARG((VisContainerInterfacePtr));
/* Functions that map one VisContainerInterfacePtr value into another
 *   On exit-
 *     VisContainerInterfacePtrMapFct = image of the argument under the map
 ***/

typedef VisContainerInterfacePtr (*VisContainerInterfacePtrSumFct) ELI_ARG((VisContainerInterfacePtr, VisContainerInterfacePtr));
/* Functions that combine two VisContainerInterfacePtr values
 *   On exit-
 *     VisContainerInterfacePtrSumFct = combination of the two arguments
 ***/

#endif
