
#ifndef VisCrossAreaPtrFUNCTIONTYPES_H
#define VisCrossAreaPtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisCrossAreaPtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisCrossAreaPtrCmpFctType) ELI_ARG((VisCrossAreaPtr, VisCrossAreaPtr));
/* Functions that compare two VisCrossAreaPtr values
 *   If the left argument is less than the right then on exit-
 *     VisCrossAreaPtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisCrossAreaPtrCmpFctType = 0
 *   Else on exit-
 *     VisCrossAreaPtrCmpFctType = 1
 ***/

typedef VisCrossAreaPtr (*VisCrossAreaPtrMapFct) ELI_ARG((VisCrossAreaPtr));
/* Functions that map one VisCrossAreaPtr value into another
 *   On exit-
 *     VisCrossAreaPtrMapFct = image of the argument under the map
 ***/

typedef VisCrossAreaPtr (*VisCrossAreaPtrSumFct) ELI_ARG((VisCrossAreaPtr, VisCrossAreaPtr));
/* Functions that combine two VisCrossAreaPtr values
 *   On exit-
 *     VisCrossAreaPtrSumFct = combination of the two arguments
 ***/

#endif
