
#ifndef VisMovablePtrFUNCTIONTYPES_H
#define VisMovablePtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisMovablePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisMovablePtrCmpFctType) ELI_ARG((VisMovablePtr, VisMovablePtr));
/* Functions that compare two VisMovablePtr values
 *   If the left argument is less than the right then on exit-
 *     VisMovablePtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisMovablePtrCmpFctType = 0
 *   Else on exit-
 *     VisMovablePtrCmpFctType = 1
 ***/

typedef VisMovablePtr (*VisMovablePtrMapFct) ELI_ARG((VisMovablePtr));
/* Functions that map one VisMovablePtr value into another
 *   On exit-
 *     VisMovablePtrMapFct = image of the argument under the map
 ***/

typedef VisMovablePtr (*VisMovablePtrSumFct) ELI_ARG((VisMovablePtr, VisMovablePtr));
/* Functions that combine two VisMovablePtr values
 *   On exit-
 *     VisMovablePtrSumFct = combination of the two arguments
 ***/

#endif
