
#ifndef VisRelationLabelPtrFUNCTIONTYPES_H
#define VisRelationLabelPtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisRelationLabelPtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisRelationLabelPtrCmpFctType) ELI_ARG((VisRelationLabelPtr, VisRelationLabelPtr));
/* Functions that compare two VisRelationLabelPtr values
 *   If the left argument is less than the right then on exit-
 *     VisRelationLabelPtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisRelationLabelPtrCmpFctType = 0
 *   Else on exit-
 *     VisRelationLabelPtrCmpFctType = 1
 ***/

typedef VisRelationLabelPtr (*VisRelationLabelPtrMapFct) ELI_ARG((VisRelationLabelPtr));
/* Functions that map one VisRelationLabelPtr value into another
 *   On exit-
 *     VisRelationLabelPtrMapFct = image of the argument under the map
 ***/

typedef VisRelationLabelPtr (*VisRelationLabelPtrSumFct) ELI_ARG((VisRelationLabelPtr, VisRelationLabelPtr));
/* Functions that combine two VisRelationLabelPtr values
 *   On exit-
 *     VisRelationLabelPtrSumFct = combination of the two arguments
 ***/

#endif
