
#ifndef VisRelationTypePtrFUNCTIONTYPES_H
#define VisRelationTypePtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisRelationTypePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisRelationTypePtrCmpFctType) ELI_ARG((VisRelationTypePtr, VisRelationTypePtr));
/* Functions that compare two VisRelationTypePtr values
 *   If the left argument is less than the right then on exit-
 *     VisRelationTypePtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisRelationTypePtrCmpFctType = 0
 *   Else on exit-
 *     VisRelationTypePtrCmpFctType = 1
 ***/

typedef VisRelationTypePtr (*VisRelationTypePtrMapFct) ELI_ARG((VisRelationTypePtr));
/* Functions that map one VisRelationTypePtr value into another
 *   On exit-
 *     VisRelationTypePtrMapFct = image of the argument under the map
 ***/

typedef VisRelationTypePtr (*VisRelationTypePtrSumFct) ELI_ARG((VisRelationTypePtr, VisRelationTypePtr));
/* Functions that combine two VisRelationTypePtr values
 *   On exit-
 *     VisRelationTypePtrSumFct = combination of the two arguments
 ***/

#endif
