
#ifndef VisRelationTypeReferencePtrFUNCTIONTYPES_H
#define VisRelationTypeReferencePtrFUNCTIONTYPES_H

#include "eliproto.h"

/* include header file defining VisRelationTypeReferencePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

typedef int (*VisRelationTypeReferencePtrCmpFctType) ELI_ARG((VisRelationTypeReferencePtr, VisRelationTypeReferencePtr));
/* Functions that compare two VisRelationTypeReferencePtr values
 *   If the left argument is less than the right then on exit-
 *     VisRelationTypeReferencePtrCmpFctType = -1
 *   Else if the arguments are equal then on exit-
 *     VisRelationTypeReferencePtrCmpFctType = 0
 *   Else on exit-
 *     VisRelationTypeReferencePtrCmpFctType = 1
 ***/

typedef VisRelationTypeReferencePtr (*VisRelationTypeReferencePtrMapFct) ELI_ARG((VisRelationTypeReferencePtr));
/* Functions that map one VisRelationTypeReferencePtr value into another
 *   On exit-
 *     VisRelationTypeReferencePtrMapFct = image of the argument under the map
 ***/

typedef VisRelationTypeReferencePtr (*VisRelationTypeReferencePtrSumFct) ELI_ARG((VisRelationTypeReferencePtr, VisRelationTypeReferencePtr));
/* Functions that combine two VisRelationTypeReferencePtr values
 *   On exit-
 *     VisRelationTypeReferencePtrSumFct = combination of the two arguments
 ***/

#endif
