namespace eval ::output {
}

proc ::output::opennew {title} {

    set window [::MDIFrame::New_Window $title ""]

    pack $window -expand true -fill both

    frame $window.out
    text $window.out.text -relief sunken \
	    -font "Courier -14" \
	    -yscrollcommand [list $window.out.ys set] \
	    -xscrollcommand [list $window.out.xs set] \
	    -width 60 -height 3 -wrap none

    scrollbar $window.out.ys -orient vertical -command "$window.out.text yview"
    frame $window.out.bt
    scrollbar $window.out.xs -orient horizontal -command "$window.out.text xview"
    set pad [expr [$window.out.ys cget -width] + 2 * \
	    ([$window.out.ys cget -bd] + [$window.out.ys cget -highlightthickness])]
    frame $window.out.pad -width $pad -height $pad
    pack $window.out.bt -side bottom -fill x
    pack $window.out.pad -in $window.out.bt -side right
    pack $window.out.xs -in $window.out.bt -side bottom -fill x
    pack $window.out.ys -side right -fill y
    pack $window.out.text -side right -fill both -expand true
    pack $window.out -side right -fill both -expand true

    oop::setClass [::MDIFrame::GetClient $window] output
    return $window
}

proc ::output::addline {window text} {
    set line [$window.out.text index "end - 1 char"]
    $window.out.text insert $line "$text\n"
}


